Subject: Re: Deadname rewriting

From: Ævar Arnfjörð Bjarmason <[email-masked]>
Date: Sat, 15 Jun 2019 10:19:02 +0200

On Sat, Jun 15 2019, Phil Hord wrote:

> I know name-scrubbing is already covered in filter-branch and other
> places. But we have a scenario becoming more common that makes it a
> more sensitive topic.
>
> At $work we have a long time employee who has changed their name from
> Alice to Bob.  Bob doesn't want anyone to call him "Alice" anymore and
> is prone to be offended if they do.  This is called "deadnaming".
>
> We are able to convince most of our work tools to expunge the deadname
> from usage anywhere, but git stubbornly calls Bob "Alice" whenever
> someone asks for "git blame" or checks in "git log".
>
> We could rewrite history with filter-branch, but that's quite
> disruptive.  I found some alternatives.
>
> .mailmap seems perfect for this task, but it doesn't work everywhere
> (blame, log, etc.).  Also, it requires the deadname to be forever
> proclaimed in the .mailmap file itself.
>
> `git replace` works rather nicely, except all of Bob's old commits
> show "replaced" in the decorator list. Also, it doesn't propagate well
> from the central server since `refs/replaces` namespace isn't fetched
> normally.  But in case anyone wants it, here's what I did:
>
> git log --author=alice.smith --format="%h" --all |
>    while read hash ; do
>       GIT_EDITOR='sed -i -e s/Alice Smith/Bob Smith/g' -e
> 's/alice.smith/bob.smith/' \
>       git replace --edit $hash
>    done
> git push origin 'refs/replace/*:refs/replace/*'
>
> I'd quite like the .mailmap solution to work, and I might flesh that
> out that some day.
>
> It feels like `.git/info/grafts` would work the best if it could be
> distributed with the project, but I'm pretty sure that's a non-starter
> for many reasons.
>
> Any other ideas?  Has anyone here encountered this already?

What should be done is to extend the .mailmap support to other
cases. I.e. make tools like blame, shortlog etc. show the equivalent of
%aN and %aE by default.

This topic was discussed at the last git contributor summit (brought up
by CB Bailey) resulting in this patch, which I see didn't make it in &
needs to be resurrected again:
https://public-inbox.org/git/[email-masked]/

So, patches welcome :)

What's not going to be supported is some notion of 100% forgetting that
there was ever an Alice that's now called Bob. They did in fact create
commit objects with "Alice" in them, and low-level plumbing like
"cat-file -p <commit>" is always going to show that, and there's going
to be the mapping in .mailmap.

But as far as porcelain UI things that would show the mailmapped value
goes those can be made to always show "Bob".

Unless of course your $work is willing to completely rewrite the repo...